#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <TimerOne.h>
int a=0;
int b=0;
int c=0;

unsigned char table[10]={'0','1','2','3','4','5','6','7','8','9'};
//int key=0;
int sped_ctr=150;
int sped_change=1;
int sped_dir=0;
int sped_get=0;

LiquidCrystal_I2C lcd(0x27,16,2);  
void setup()
{
   Serial.begin(9600);
   lcd.init();                      // initialize the lcd 
 
  // Print a message to the LCD.
  lcd.backlight();
 lcd.print("PWM");
 lcd.setCursor(0,1);
 lcd.print("SPEED:");
   
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR((byte *)"clie1");
  Mirf.setTADDR((byte *)"serv1");  
  Mirf.payload = sizeof(unsigned long);
  Mirf.config(); 
  
  pinMode(13, OUTPUT);
  
  pinMode(22,INPUT);
  pinMode(23,INPUT);
  pinMode(24,INPUT);
  pinMode(25,INPUT);
  
//digitalWrite(22,HIGH)  ;
//digitalWrite(23,HIGH)  ;
//digitalWrite(24,HIGH)  ;
//digitalWrite(25,HIGH)  ;
  
}

void putstring(byte *str)
{
    while(*str!='\0'){
        Serial.write(*str++);
    }
}


void spedget()
{
  byte rx_data[Mirf.payload];
   if( Mirf.dataReady())
   {
     Mirf.getData(rx_data);
     //putstring(rx_data);
           a= rx_data[0];
           b=rx_data[1];
           c=rx_data[2];
      Serial.print((char)rx_data[0]);
      Serial.print((char)rx_data[1]);
      Serial.print((char)rx_data[2]);
      Serial.print('\n');
     sped_get = ((int)rx_data[0])*100+((int)rx_data[1])*10+((int)rx_data[2]);
    // sped_get=123;
    } 
}

void keyscan()
{
 
  if(digitalRead(22) == LOW)
  {
  sped_change++;
  if(sped_change==1)
  sped_ctr=50;
  if(sped_change==2)
  sped_ctr=150;
  if(sped_change==3)
  sped_ctr=250;
 if(sped_change==4)
 sped_change=0;
 
  
  
  while(!digitalRead(22));
  spedsend();
  }
  
 else if(digitalRead(23) == LOW)
  {
  //delay(10);
  sped_dir=~sped_dir;
    while(!digitalRead(23));
}
 else if(digitalRead(24) == LOW)
{
 // delay(10);
  if(sped_dir==0)
  sped_ctr=sped_ctr-5;
  else  sped_ctr=sped_ctr-10;
     while(!digitalRead(24));
     spedsend();
}
 else if(digitalRead(25) == LOW)
{
  //delay(10);
  if(sped_dir==0)
  sped_ctr=sped_ctr+5;
  else  sped_ctr=sped_ctr+10;
  while(!digitalRead(25));
  spedsend();
}
 lcd.setCursor(4,0);
if(sped_ctr>99)
{
 lcd.print(sped_ctr);
}
else {
  lcd.print("   ");
  lcd.setCursor(4,0);
  lcd.print(sped_ctr);
  delay(20);
}
}

void spedsend()
{
   byte tx_data[Mirf.payload];
   tx_data[0]=table[sped_ctr/100];
  tx_data[1]=table[sped_ctr%100/10];
  tx_data[2]=table[sped_ctr%10];
  tx_data[3]='\n';
  tx_data[4]='\0';
   Mirf.send((byte *)&tx_data);  
      while(Mirf.isSending());
    // putstring(tx_data);
}


void loop()
{
 // spedsend();
  keyscan();
   spedget();
   //delay(10);
  // lcd.setCursor(0,1);
   //lcd.print(s);
   lcd.setCursor(7,1);
  lcd.print((char) a);
   lcd.print((char) b);
    lcd.print((char) c);
   
   
   
}
