#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
#include <TimerOne.h>


unsigned char table[10]={'0','1','2','3','4','5','6','7','8','9'};

unsigned int sped,tem_speed;
int PWM_CTR = 5;
int spedsend_flag=0;
int sped_ctr = 150;

void putstring(byte *str)
{
    while(*str!='\0'){
        Serial.write(*str++);
    }
}

void setup()
{
   Serial.begin(9600);
   
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setRADDR((byte *)"clie1");
  Mirf.setTADDR((byte *)"serv1");  
  Mirf.payload = sizeof(unsigned long);
  Mirf.config(); 
  attachInterrupt(1,cnt,FALLING);
  // Initialize the digital pin as an output.
  // Pin 13 has an LED connected on most Arduino boards
  pinMode(13, OUTPUT);    
  Timer1.initialize(1000000); // set a timer of length 100000 microseconds (or 0.1 sec - or 10Hz => the led will blink 5 times, 5 cycles of on-and-off, per second)
  Timer1.attachInterrupt( timerIsr ); // attach the service routine here
  
}


void loop()
{
  
   
   
   analogWrite(PWM_CTR,sped_ctr);
   
   if(spedsend_flag==1)
       spedsend(); 
      spedget();
//   lcd.setCursor(0,0);
 // lcd.print("Hello, world!");
 // lcd.setCursor(0,1);
 // lcd.print(tem_speed/100);
 //lcd.print(tem_speed%100/10);
   // lcd.print(tem_speed%10);
}

void spedget()
{
  byte rx_data[Mirf.payload];
   if( Mirf.dataReady())
   {
     Mirf.getData(rx_data);
     delay(20);
      Serial.print("o");
     //putstring(rx_data);
     sped_ctr = rx_data[0]*100+rx_data[1]*10+rx_data[2];
    } 
    
    
}

void spedsend()
{
   
   byte tx_data[Mirf.payload];
  //tx_data[0]=(byte )tem_speed/100;
  //tx_data[1]=(byte )tem_speed%100/10;
  //tx_data[2]=(byte )tem_speed%10;
  tx_data[0]=table[tem_speed/100];
  tx_data[1]=table[tem_speed%100/10];
  tx_data[2]=table[tem_speed%10];
  tx_data[3]='\n';
  tx_data[4]='\0';
   Mirf.send((byte *)&tx_data);  
      while(Mirf.isSending());
      spedsend_flag=0;
      putstring(tx_data);
}

void timerIsr()
{
  
    // Toggle LED
    digitalWrite( 13, digitalRead( 13 ) ^ 1 );
    tem_speed = sped;
    sped=0;
    spedsend_flag=1;
  //  Serial.print('h');
}

void cnt()
{
  
  sped++;
  
}

